<template>
  <div class="app-container">
    <!-- 查询和其他操作-->
    <div class="filter-container">
      <el-input v-model="listQuery.cityName" clearable class="filter-item" style="width: 200px;" placeholder="请输入城市" />

      <el-select v-model="listQuery.cityLevel" class="filter-item" placeholder="请选择等级" clearable>
        <el-option v-for="(value, key) in levels" :key="key" :label="value" :value="key" />
      </el-select>
      <el-button v-permission="['GET /admin/city/list']" class="filter-item" type="primary" icon="el-icon-search"
        @click="handleFilter">查找</el-button>
      <!-- <el-button :loading="downloadLoading" class="filter-item" type="primary" icon="el-icon-download" @click="handleDownload">导出</el-button> -->
    </div>

    <!--<div class="operator-container"> -->
    <div class="filter-container">
      <el-button v-permission="['POST /admin/city/create']" class="filter-item" type="primary" icon="el-icon-edit"
        @click="handleCreate">添加</el-button>
      <!--<el-button v-permission="['GET /admin/city/batch-delete']" class="filter-item" type="danger" icon="el-icon-delete" @click="handleBatchDelete">批量删除</el-button>-->
    </div>

    <!-- 查询结果 -->
    <el-table v-loading="listLoading" :data="list" element-loading-text="正在查询中。。。" border fit highlight-current-row
      @selection-change="handleSelectionChange">
      <!--<el-table-column type="selection" width="55" />-->
      <el-table-column align="center" label="省份" prop="province" />
      <el-table-column align="center" label="城市" prop="cityName" />
      <el-table-column align="center" label="城市等级" prop="cityLevel" />
      <el-table-column align="center" label="城市位置" prop="cityCenter" />
      <el-table-column align="center" label="创建时间" prop="createTime" /> 

      <el-table-column align="center" label="操作" min-width="100" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button v-permission="['POST /admin/city/update']" type="primary" size="mini"
            @click="handleUpdate(scope.row)">编辑</el-button>
          <el-button v-permission="['POST /admin/city/delete']" type="danger" size="mini" @click="handleDelete(scope.row)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="listQuery.page" :limit.sync="listQuery.limit"
      @pagination="getList" />

    <!-- 添加或修改对话框 -->
    <el-dialog :title="textMap[dialogStatus]" :visible.sync="dialogFormVisible">
      <el-form ref="dataForm" :rules="rules" :model="dataForm" status-icon label-position="left" label-width="100px"
        style="width: 300px; margin-left:50px;">
        <el-form-item label="城市名称" prop="cityName">
          <el-input :readonly="dialogStatus == 'update'" v-model="dataForm.cityName" placeholder="请输入城市名称" />
        </el-form-item>
        <el-form-item label="城市级别" prop="cityLevel">
          <el-select v-model="dataForm.cityLevel" class="filter-item" placeholder="请选择等级" clearable>
            <el-option v-for="(value, key) in levels" :key="key" :label="value" :value="key" />
          </el-select>
        </el-form-item>
        
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">取消</el-button>
        <el-button v-if="dialogStatus == 'create'" type="primary" @click="createData">确定</el-button>
        <el-button v-else type="primary" @click="updateData">确定</el-button>
      </div>
    </el-dialog>

    <el-tooltip placement="top" content="返回顶部">
      <back-to-top :visibility-height="100" />
    </el-tooltip>
  </div>
</template>

<style>
.el-table th.gutter {
  display: table-cell !important;
}

.el-dialog {
  width: 800px;
}
</style>

<script>
import {
  listCity,
  deleteCity,
  updateCity,
  readCity,
  createCity
} from "@/api/city";
import { getShop } from "@/api/goods";
import BackToTop from "@/components/BackToTop";
import Pagination from "@/components/Pagination"; // Secondary package based on el-pagination
import _ from "lodash";

export default {
  name: "Topic",
  components: { BackToTop, Pagination },
  data() {
    return {
      levels: { "A": "A.直辖市", "B": "B.一线城市", "C": "C.地级市" },
      list: [],
      total: 0,
      listLoading: true,
      listQuery: {
        page: 1,
        limit: 20,
        sort: "create_time",
        order: "desc",
        cityName: '',
        cityLevel: ''
      },
      dataForm: {
        id: undefined,
        cityName: "", 
        cityLevel: ""
      },
      shops: [],
      dialogFormVisible: false,
      dialogStatus: "",
      textMap: {
        update: "编辑",
        create: "创建"
      },
      rules: {
        cityName: [{ required: true, message: "城市名称不能为空", trigger: "blur" }],
        cityLevel:[{ required: true, message: "城市级别不能为空", trigger: "blur" }]
      },
      options: [
        {
          value: "id",
          label: "按序号排序"
        },
        {
          value: "create_time",
          label: "按时间排序"
        }
      ],
      multipleSelection: [],
      contentDetail: "",
      contentDialogVisible: false,
      downloadLoading: false
    };
  },
  created() {
    this.getList();
    getShop().then(res => {
      console.info(res);
      this.shops = res.data.data;
    });
  },
  methods: {
    getList() {
      this.listLoading = true;
      listCity(this.listQuery)
        .then(response => {
          this.list = response.data.data.list;
          this.total = response.data.data.total;
          this.listLoading = false;
        })
        .catch(() => {
          this.list = [];
          this.total = 0;
          this.listLoading = false;
        });
    },

    handleFilter() {
      this.listQuery.page = 1;
      this.getList();
    },
    handleCreate() {
      this.resetForm();
      this.dialogStatus = "create";
      this.dialogFormVisible = true;
      this.$nextTick(() => {
        this.$refs["dataForm"].clearValidate();
      });
    },
    resetForm() {
      this.dataForm = {
        id: undefined,
        cityName: "",
        areaId: undefined,
        cityAddress: undefined,
        defaultShopId: ""
      };
    },
    createData() {
      this.$refs["dataForm"].validate(valid => {
        if (valid) {
          createCity(this.dataForm)
            .then(response => {
              this.list.unshift(response.data.data);
              this.dialogFormVisible = false;
              this.$notify.success({
                title: "成功",
                message: "创建成功"
              });
            })
            .catch(response => {
              this.$notify.error({
                title: "失败",
                message: response.data.errmsg
              });
            });
        }
      });
    },
    handleUpdate(row) {
      this.dataForm = Object.assign({}, row);
      this.dialogStatus = "update";
      this.dialogFormVisible = true;
      this.$nextTick(() => {
        this.$refs["dataForm"].clearValidate();
      });
    },
    updateData() {
      this.$refs["dataForm"].validate(valid => {
        if (valid) {
          updateCity(this.dataForm)
            .then(() => {
              for (const v of this.list) {
                if (v.id === this.dataForm.id) {
                  const index = this.list.indexOf(v);
                  this.list.splice(index, 1, this.dataForm);
                  break;
                }
              }
              this.dialogFormVisible = false;
              this.$notify.success({
                title: "成功",
                message: "更新成功"
              });
              this.getList();
            })
            .catch(response => {
              this.$notify.error({
                title: "失败",
                message: response.data.errmsg
              });
            });
        }
      });
    },
    handleDelete(row) {
      deleteCity(row)
        .then(response => {
          this.$notify.success({
            title: "成功",
            message: "删除城市成功"
          });
          const index = this.list.indexOf(row);
          this.list.splice(index, 1);
        })
        .catch(response => {
          this.$notify.error({
            title: "失败",
            message: response.data.errmsg
          });
        });
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    showContent(content) {
      this.contentDetail = content;
      this.contentDialogVisible = true;
    },
    handleBatchDelete() {
      if (this.multipleSelection.length === 0) {
        this.$message.error("请选择至少一条记录");
        return;
      }
      const ids = [];
      _.forEach(this.multipleSelection, function (item) {
        ids.push(item.id);
      });
      batchDeleteTopic({ ids: ids })
        .then(response => {
          this.$notify.success({
            title: "成功",
            message: "批量删除专题成功"
          });
          this.getList();
        })
        .catch(response => {
          this.$notify.error({
            title: "失败",
            message: response.data.errmsg
          });
        });
    }, 
  }
};
</script>
